cascading.util

## Class Util

- java.lang.Object
- - cascading.util.Util

-     public class Util
      extends Object

  Class Util provides reusable operations.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `Util.RetryOperator<T>`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `CONVERT_DOT_TO_PDF` On OS X only, and if the graphviz dot binary is installed, when true, dot will be invoked to convert the dot file to a pdf document.
    `static boolean` | `HAS_DOT_EXEC`
    `static int` | `ID_LENGTH`
    `static boolean` | `IS_OSX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Util()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Set<Class<? extends Exception>>` | `asClasses(String classNames, String warningMessage)` Converts a given comma separated String of Exception names into a List of classes.
    `static String` | `cleansePathName(String name)`
    `static <T> boolean` | `contains(Class<T> type, Collection collection)`
    `static <T> boolean` | `contains(Class<T> type, Iterator iterator)`
    `static boolean` | `containsNull(Object[] values)`
    `static boolean` | `containsWhitespace(String string)`
    `static <T> T[]` | `copy(T[] source)`
    `static <K,V> HashMap<K,V>` | `createHashMap()`
    `static String` | `createID(byte[] bytes)` Method CreateID returns a HEX hash of the given bytes with length 32 characters long.
    `static String` | `createID(String rawID)`
    `static <V> Set<V>` | `createIdentitySet()`
    `static <V> Set<V>` | `createIdentitySet(Collection<V> collection)`
    `static Object` | `createProtectedObject(Class type, Object[] parameters, Class[] parameterTypes)`
    `static String` | `createUniqueID()`
    `static String` | `createUniqueIDWhichStartsWithAChar()`
    `static <T> Set<T>` | `differenceIdentity(Set<T> lhs, Set<T> rhs)`
    `static int` | `execProcess(File parentFile, String... command)`
    `static String` | `findContainingJar(Class<?> type)`
    `static Class` | `findMainClass(Class defaultType, String packageExclude)`
    `static String` | `findName(String path)`
    `static String` | `findVersion(String path)`
    `static String` | `formatDurationDHMSms(long duration)`
    `static String` | `formatDurationFromMillis(long duration)`
    `static String` | `formatDurationHMSms(long duration)`
    `static String` | `formatDurationMSms(long duration)`
    `static <V> V` | `getFirst(Collection<V> collection)`
    `static <V> V` | `getFirst(Iterator<V> iterator)`
    `static String` | `getHex(byte[] bytes)`
    `static <V> V` | `getLast(Iterator<V> iterator)`
    `static String` | `getSimpleTypeName(Type type)`
    `static long` | `getSinkModified(Object config, Collection<Tap> sinks)`
    `static long` | `getSourceModified(Object confCopy, Iterator<Tap> values, long sinkModified)`
    `static String` | `getTypeName(Type type)`
    `static boolean` | `hasClass(String typeString)`
    `static boolean` | `hasInstanceMethod(Object target, String methodName, Class[] parameterTypes)`
    `static byte[]` | `intToByteArray(int value)`
    `static <T> T` | `invokeConstructor(Class<T> target, Object[] parameters, Class[] parameterTypes)`
    `static Object` | `invokeConstructor(String className, Object[] parameters, Class[] parameterTypes)`
    `static Object` | `invokeInstanceMethod(Object target, String methodName, Object[] parameters, Class[] parameterTypes)`
    `static Object` | `invokeInstanceMethodSafe(Object target, String methodName, Object[] parameters, Class[] parameterTypes)`
    `static Object` | `invokeStaticMethod(Class type, String methodName, Object[] parameters, Class[] parameterTypes)`
    `static Object` | `invokeStaticMethod(String typeString, String methodName, Object[] parameters, Class[] parameterTypes)`
    `static boolean` | `isEmpty(String string)`
    `static String` | `join(Collection collection)` This method joins each value in the collection with a tab character as the delimiter.
    `static String` | `join(Collection collection, String delim)` This method joins each valuein the collection with the given delimiter.
    `static String` | `join(Collection collection, String delim, boolean printNull)`
    `static String` | `join(int[] list, String delim)` This method joins the values in the given list with the delim String value.
    `static String` | `join(int[] list, String delim, boolean printNull)`
    `static String` | `join(Iterable iterable, String delim, boolean printNull)`
    `static String` | `join(Object[] list, String delim)` This method joins the values in the given list with the delim String value.
    `static String` | `join(Object[] list, String delim, boolean printNull)`
    `static String` | `join(Object[] list, String delim, boolean printNull, int beginAt)`
    `static String` | `join(Object[] list, String delim, boolean printNull, int beginAt, int length)`
    `static String` | `join(String delim, boolean printNull, String... strings)`
    `static void` | `join(StringBuffer buffer, Collection collection, String delim)` This method joins each value in the collection with the given delimiter.
    `static void` | `join(StringBuffer buffer, Collection collection, String delim, boolean printNull)`
    `static String` | `join(String delim, String... strings)`
    `static Class<?>` | `loadClass(String typeString)`
    `static Class<?>` | `loadClassSafe(String typeString)`
    `static byte[]` | `longToByteArray(long value)`
    `static String` | `makePath(String prefix, String name)`
    `static <N extends Number> N` | `max(Collection<N> collection)`
    `static <N extends Number> N` | `min(Collection<N> collection)`
    `static <T> Set<T>` | `narrowIdentitySet(Class<T> type, Collection collection)`
    `static <T> Set<T>` | `narrowIdentitySet(Class<T> type, Collection collection, boolean include)`
    `static <T> Set<T>` | `narrowIdentitySet(Class<T> type, Iterator iterator)`
    `static <T> Set<T>` | `narrowIdentitySet(Class<T> type, Iterator iterator, boolean include)`
    `static <T> Set<T>` | `narrowSet(Class<T> type, Collection collection)`
    `static <T> Set<T>` | `narrowSet(Class<T> type, Collection collection, boolean include)`
    `static <T> Set<T>` | `narrowSet(Class<T> type, Iterator iterator)`
    `static <T> Set<T>` | `narrowSet(Class<T> type, Iterator iterator, boolean include)`
    `static <T> T` | `newInstance(Class<T> target, Object... parameters)`
    `static <T> T` | `newInstance(String className, Object... parameters)`
    `static String` | `normalizeUrl(String url)` This method attempts to remove duplicate consecutive forward slashes from the given url.
    `static String` | `parseHostname(String uri)`
    `static String` | `print(Collection collection, String delim)`
    `static void` | `print(StringBuffer buffer, Collection collection, String delim)`
    `static void` | `printGraph(String filename, org.jgrapht.graph.SimpleDirectedGraph graph)`
    `static Collection<String>` | `quote(Collection<String> collection, String quote)`
    `static void` | `removeAllNulls(List list)` This method removes all nulls from the given List.
    `static String[]` | `removeNulls(String... strings)`
    `static <T> T` | `retry(org.slf4j.Logger logger, int retries, int secondsDelay, String message, Util.RetryOperator<T> operator)`
    `static <R> R` | `returnInstanceFieldIfExists(Object target, String fieldName)`
    `static <R> R` | `returnInstanceFieldIfExistsSafe(Object target, String fieldName)`
    `static <K,V> boolean` | `reverseMap(Map<V,K> from, Map<K,V> to)`
    `static void` | `safeSleep(long durationMillis)`
    `static String` | `sanitizeUrl(String url)` This method attempts to remove any username and password from the given url String.
    `static <R> void` | `setInstanceFieldIfExists(Object target, String fieldName, R value)`
    `static <R> boolean` | `setInstanceFieldIfExistsSafe(Object target, String fieldName, R value)`
    `static String[]` | `simpleTypeNames(Type[] types)`
    `static <T> List<T>` | `split(Class<T> type, String values)`
    `static <T> List<T>` | `split(Class<T> type, String delim, String values)`
    `static Boolean` | `submitWithTimeout(Callable<Boolean> task, int timeout, TimeUnit timeUnit)`
    `static String` | `toNull(Object object)` This method returns the `Object.toString()` of the given object, or an empty String if the object is null.
    `static String` | `truncate(String string, int maxSize)` This method truncates the given String value to the given size, but appends an ellipse ("...") if the String is larger than maxSize.
    `static String[]` | `typeNames(Type[] types)`
    `static String` | `unique(String value, String delim)`
    `static void` | `writeDOT(Writer writer, org.jgrapht.DirectedGraph graph, IntegerNameProvider vertexIdProvider, VertexNameProvider vertexNameProvider, EdgeNameProvider edgeNameProvider)`
    `static void` | `writeDOT(Writer writer, org.jgrapht.DirectedGraph graph, IntegerNameProvider vertexIdProvider, VertexNameProvider vertexNameProvider, EdgeNameProvider edgeNameProvider, ComponentAttributeProvider vertexAttributeProvider, ComponentAttributeProvider edgeAttributeProvider)`
    `static void` | `writePDF(String path)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### CONVERT_DOT_TO_PDF

          public static final String CONVERT_DOT_TO_PDF

      On OS X only, and if the graphviz dot binary is installed, when true, dot will be invoked to convert the dot file to a pdf document.
      See Also:
        Constant Field Values

    - #### ID_LENGTH

          public static int ID_LENGTH

    - #### IS_OSX

          public static final boolean IS_OSX

    - #### HAS_DOT_EXEC

          public static final boolean HAS_DOT_EXEC

  - ### Constructor Detail

    - #### Util

          public Util()

  - ### Method Detail

    - #### createHashMap

          public static <K,V> HashMap<K,V> createHashMap()

    - #### reverseMap

          public static <K,V> boolean reverseMap(Map<V,K> from,
                                 Map<K,V> to)

    - #### createIdentitySet

          public static <V> Set<V> createIdentitySet()

    - #### createIdentitySet

          public static <V> Set<V> createIdentitySet(Collection<V> collection)

    - #### getFirst

          public static <V> V getFirst(Collection<V> collection)

    - #### getFirst

          public static <V> V getFirst(Iterator<V> iterator)

    - #### getLast

          public static <V> V getLast(Iterator<V> iterator)

    - #### max

          public static <N extends Number> N max(Collection<N> collection)

    - #### min

          public static <N extends Number> N min(Collection<N> collection)

    - #### narrowSet

          public static <T> Set<T> narrowSet(Class<T> type,
                             Collection collection)

    - #### narrowIdentitySet

          public static <T> Set<T> narrowIdentitySet(Class<T> type,
                                     Collection collection)

    - #### narrowSet

          public static <T> Set<T> narrowSet(Class<T> type,
                             Collection collection,
                             boolean include)

    - #### narrowIdentitySet

          public static <T> Set<T> narrowIdentitySet(Class<T> type,
                                     Collection collection,
                                     boolean include)

    - #### narrowSet

          public static <T> Set<T> narrowSet(Class<T> type,
                             Iterator iterator)

    - #### narrowIdentitySet

          public static <T> Set<T> narrowIdentitySet(Class<T> type,
                                     Iterator iterator)

    - #### narrowSet

          public static <T> Set<T> narrowSet(Class<T> type,
                             Iterator iterator,
                             boolean include)

    - #### narrowIdentitySet

          public static <T> Set<T> narrowIdentitySet(Class<T> type,
                                     Iterator iterator,
                                     boolean include)

    - #### contains

          public static <T> boolean contains(Class<T> type,
                             Collection collection)

    - #### contains

          public static <T> boolean contains(Class<T> type,
                             Iterator iterator)

    - #### differenceIdentity

          public static <T> Set<T> differenceIdentity(Set<T> lhs,
                                      Set<T> rhs)

    - #### createUniqueIDWhichStartsWithAChar

          public static String createUniqueIDWhichStartsWithAChar()

    - #### createUniqueID

          public static String createUniqueID()

    - #### createID

          public static String createID(String rawID)

    - #### createID

          public static String createID(byte[] bytes)

      Method CreateID returns a HEX hash of the given bytes with length 32 characters long.
      Parameters:
        `bytes` - the bytes
      Returns:
        string

    - #### getHex

          public static String getHex(byte[] bytes)

    - #### longToByteArray

          public static byte[] longToByteArray(long value)

    - #### intToByteArray

          public static byte[] intToByteArray(int value)

    - #### copy

          public static <T> T[] copy(T[] source)

    - #### unique

          public static String unique(String value,
                      String delim)

    - #### join

          public static String join(int[] list,
                    String delim)

      This method joins the values in the given list with the delim String value.
      Parameters:
        `list` -
        `delim` -
      Returns:
        String

    - #### join

          public static String join(int[] list,
                    String delim,
                    boolean printNull)

    - #### join

          public static String join(String delim,
                    String... strings)

    - #### join

          public static String join(String delim,
                    boolean printNull,
                    String... strings)

    - #### join

          public static String join(Object[] list,
                    String delim)

      This method joins the values in the given list with the delim String value.
      Parameters:
        `list` -
        `delim` -
      Returns:
        a String

    - #### join

          public static String join(Object[] list,
                    String delim,
                    boolean printNull)

    - #### join

          public static String join(Object[] list,
                    String delim,
                    boolean printNull,
                    int beginAt)

    - #### join

          public static String join(Object[] list,
                    String delim,
                    boolean printNull,
                    int beginAt,
                    int length)

    - #### join

          public static String join(Iterable iterable,
                    String delim,
                    boolean printNull)

    - #### join

          public static String join(Collection collection)

      This method joins each value in the collection with a tab character as the delimiter.
      Parameters:
        `collection` -
      Returns:
        a String

    - #### join

          public static String join(Collection collection,
                    String delim)

      This method joins each valuein the collection with the given delimiter.
      Parameters:
        `collection` -
        `delim` -
      Returns:
        a String

    - #### join

          public static String join(Collection collection,
                    String delim,
                    boolean printNull)

    - #### join

          public static void join(StringBuffer buffer,
                  Collection collection,
                  String delim)

      This method joins each value in the collection with the given delimiter. All results are appended to the given `StringBuffer` instance.
      Parameters:
        `buffer` -
        `collection` -
        `delim` -

    - #### join

          public static void join(StringBuffer buffer,
                  Collection collection,
                  String delim,
                  boolean printNull)

    - #### split

          public static <T> List<T> split(Class<T> type,
                          String values)

    - #### split

          public static <T> List<T> split(Class<T> type,
                          String delim,
                          String values)

    - #### removeNulls

          public static String[] removeNulls(String... strings)

    - #### quote

          public static Collection<String> quote(Collection<String> collection,
                                 String quote)

    - #### print

          public static String print(Collection collection,
                     String delim)

    - #### print

          public static void print(StringBuffer buffer,
                   Collection collection,
                   String delim)

    - #### sanitizeUrl

          public static String sanitizeUrl(String url)

      This method attempts to remove any username and password from the given url String.
      Parameters:
        `url` -
      Returns:
        a String

    - #### normalizeUrl

          public static String normalizeUrl(String url)

      This method attempts to remove duplicate consecutive forward slashes from the given url.
      Parameters:
        `url` -
      Returns:
        a String

    - #### toNull

          public static String toNull(Object object)

      This method returns the `Object.toString()` of the given object, or an empty String if the object is null.
      Parameters:
        `object` -
      Returns:
        a String

    - #### truncate

          public static String truncate(String string,
                        int maxSize)

      This method truncates the given String value to the given size, but appends an ellipse ("...") if the String is larger than maxSize.
      Parameters:
        `string` -
        `maxSize` -
      Returns:
        a String

    - #### printGraph

          public static void printGraph(String filename,
                        org.jgrapht.graph.SimpleDirectedGraph graph)

    - #### removeAllNulls

          public static void removeAllNulls(List list)

      This method removes all nulls from the given List.
      Parameters:
        `list` -

    - #### writeDOT

          public static void writeDOT(Writer writer,
                      org.jgrapht.DirectedGraph graph,
                      IntegerNameProvider vertexIdProvider,
                      VertexNameProvider vertexNameProvider,
                      EdgeNameProvider edgeNameProvider)

    - #### writeDOT

          public static void writeDOT(Writer writer,
                      org.jgrapht.DirectedGraph graph,
                      IntegerNameProvider vertexIdProvider,
                      VertexNameProvider vertexNameProvider,
                      EdgeNameProvider edgeNameProvider,
                      ComponentAttributeProvider vertexAttributeProvider,
                      ComponentAttributeProvider edgeAttributeProvider)

    - #### isEmpty

          public static boolean isEmpty(String string)

    - #### findVersion

          public static String findVersion(String path)

    - #### findName

          public static String findName(String path)

    - #### getSourceModified

          public static long getSourceModified(Object confCopy,
                               Iterator<Tap> values,
                               long sinkModified)
                                        throws IOException

      Throws:
        `IOException`

    - #### getSinkModified

          public static long getSinkModified(Object config,
                             Collection<Tap> sinks)
                                      throws IOException

      Throws:
        `IOException`

    - #### getTypeName

          public static String getTypeName(Type type)

    - #### getSimpleTypeName

          public static String getSimpleTypeName(Type type)

    - #### typeNames

          public static String[] typeNames(Type[] types)

    - #### simpleTypeNames

          public static String[] simpleTypeNames(Type[] types)

    - #### containsNull

          public static boolean containsNull(Object[] values)

    - #### safeSleep

          public static void safeSleep(long durationMillis)

    - #### writePDF

          public static void writePDF(String path)

    - #### execProcess

          public static int execProcess(File parentFile,
                        String... command)

    - #### formatDurationFromMillis

          public static String formatDurationFromMillis(long duration)

    - #### formatDurationMSms

          public static String formatDurationMSms(long duration)

    - #### formatDurationHMSms

          public static String formatDurationHMSms(long duration)

    - #### formatDurationDHMSms

          public static String formatDurationDHMSms(long duration)

    - #### asClasses

          public static Set<Class<? extends Exception>> asClasses(String classNames,
                                                  String warningMessage)

      Converts a given comma separated String of Exception names into a List of classes. ClassNotFound exceptions are ignored if no warningMessage is given, otherwise logged as a warning.
      Parameters:
        `classNames` - A comma separated String of Exception names.
      Returns:
        List of Exception classes.

    - #### submitWithTimeout

          public static Boolean submitWithTimeout(Callable<Boolean> task,
                                  int timeout,
                                  TimeUnit timeUnit)
                                           throws Exception

      Throws:
        `Exception`

    - #### retry

          public static <T> T retry(org.slf4j.Logger logger,
                    int retries,
                    int secondsDelay,
                    String message,
                    Util.RetryOperator<T> operator)
                         throws Exception

      Throws:
        `Exception`

    - #### createProtectedObject

          public static Object createProtectedObject(Class type,
                                     Object[] parameters,
                                     Class[] parameterTypes)

    - #### hasClass

          public static boolean hasClass(String typeString)

    - #### newInstance

          public static <T> T newInstance(String className,
                          Object... parameters)

    - #### newInstance

          public static <T> T newInstance(Class<T> target,
                          Object... parameters)

    - #### invokeStaticMethod

          public static Object invokeStaticMethod(String typeString,
                                  String methodName,
                                  Object[] parameters,
                                  Class[] parameterTypes)

    - #### loadClass

          public static Class<?> loadClass(String typeString)

    - #### loadClassSafe

          public static Class<?> loadClassSafe(String typeString)

    - #### invokeStaticMethod

          public static Object invokeStaticMethod(Class type,
                                  String methodName,
                                  Object[] parameters,
                                  Class[] parameterTypes)

    - #### hasInstanceMethod

          public static boolean hasInstanceMethod(Object target,
                                  String methodName,
                                  Class[] parameterTypes)

    - #### invokeInstanceMethodSafe

          public static Object invokeInstanceMethodSafe(Object target,
                                        String methodName,
                                        Object[] parameters,
                                        Class[] parameterTypes)

    - #### invokeInstanceMethod

          public static Object invokeInstanceMethod(Object target,
                                    String methodName,
                                    Object[] parameters,
                                    Class[] parameterTypes)

    - #### returnInstanceFieldIfExistsSafe

          public static <R> R returnInstanceFieldIfExistsSafe(Object target,
                                              String fieldName)

    - #### invokeConstructor

          public static Object invokeConstructor(String className,
                                 Object[] parameters,
                                 Class[] parameterTypes)

    - #### invokeConstructor

          public static <T> T invokeConstructor(Class<T> target,
                                Object[] parameters,
                                Class[] parameterTypes)

    - #### returnInstanceFieldIfExists

          public static <R> R returnInstanceFieldIfExists(Object target,
                                          String fieldName)

    - #### setInstanceFieldIfExistsSafe

          public static <R> boolean setInstanceFieldIfExistsSafe(Object target,
                                                 String fieldName,
                                                 R value)

    - #### setInstanceFieldIfExists

          public static <R> void setInstanceFieldIfExists(Object target,
                                          String fieldName,
                                          R value)

    - #### makePath

          public static String makePath(String prefix,
                        String name)

    - #### cleansePathName

          public static String cleansePathName(String name)

    - #### findMainClass

          public static Class findMainClass(Class defaultType,
                            String packageExclude)

    - #### findContainingJar

          public static String findContainingJar(Class<?> type)

    - #### containsWhitespace

          public static boolean containsWhitespace(String string)

    - #### parseHostname

          public static String parseHostname(String uri)

Copyright © 2007-2015 Concurrent, Inc. All Rights Reserved.